VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMail"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================


'Diese Klasse stellt eine Methode zur Verfgung mit der ein einfaches Mail versendet werden kann

Option Explicit
Option Base 1

Private OutlookApp As outlook.Application
Private bOutlookBereitsGeoeffnet As Boolean
Private bOutlookGefunden As Boolean

' Outlook-Objekt bei Bedarf erstellen
Private Sub Class_Initialize()
   ' Dim Protokoll As clsProtokoll
    
    bOutlookGefunden = True
    bOutlookBereitsGeoeffnet = True
    On Error Resume Next
    Set OutlookApp = GetObject(, "Outlook.Application")
    
    If (Err <> 0) Then
        Err.Clear
        Set OutlookApp = CreateObject("Outlook.Application")
        If (Err <> 0) Then
            MsgBox "Outlook ist auf diesem Rechner nicht installiert! Bitte kontaktieren sie den Administrator.", vbOKOnly + vbCritical, "Warnung"
            bOutlookGefunden = False
        End If
        bOutlookBereitsGeoeffnet = False
    End If
End Sub

Public Sub sendeMail(ByVal sMailAdresse As String, ByVal sMailText As String, Optional ByVal sBetreff As String = "")
    Dim Mail As outlook.MailItem
    
    If (bOutlookGefunden = False) Then Exit Sub
    Set Mail = OutlookApp.CreateItem(olMailItem)
    
    With Mail
        .To = sMailAdresse
        .Subject = sBetreff
        .Body = sMailText
        .Send
    End With
    
    Set Mail = Nothing
End Sub

' Outlook
Private Sub Class_Terminate()
    If (bOutlookBereitsGeoeffnet = False) Then
        OutlookApp.Quit
    End If
    Set OutlookApp = Nothing
End Sub
