VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTabellenZeilen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================


' Diese Klasse verwaltet als "Collection" (4 x !!!) die Passmae und sortiert diese beim
' .add Befehl der Gre nach ein

Option Explicit

Private codNennMass As Collection               ' geht nicht anders !
Private cosToleranz As Collection
Private codUnteresAbmass As Collection
Private codOberesAbmass As Collection


' Collection instanzieren
Private Sub Class_Initialize()
    Set codNennMass = New Collection              ' Collections instanzieren
    Set cosToleranz = New Collection
    Set codUnteresAbmass = New Collection
    Set codOberesAbmass = New Collection
End Sub

' eine neue Zeile hinzufgen und gleich richtig einsortieren ! (Nennma & Toleranz absteigend !)
Public Sub add(ByVal dNennMass As Double, ByVal sToleranz As String, ByVal dUnteresAbmass As Double, ByVal dOberesAbmass As Double)
    Dim lElement As Long
    Dim bZeileEingefuegt As Boolean
    Dim sNeuerIndex As String, sAlterIndex As String                ' Nennma & Toleranz
    bZeileEingefuegt = False
        
    sNeuerIndex = LCase$(Format$(dNennMass, "0000.00")) & sToleranz ' "Index" erstellen zum Einsortieren !
    For lElement = 1 To codNennMass.Count
        
        sAlterIndex = Format$(codNennMass.Item(lElement), "0000.00") & cosToleranz.Item(lElement)
        'If (codNennMass.Item(lElement) <= dNennMass) Then
        If (sAlterIndex <= sNeuerIndex) Then                        ' genau dort
            If (codNennMass.Item(lElement) = dNennMass) And _
               (cosToleranz.Item(lElement) = sToleranz) Then        ' Doppelte nicht einsortieren
                bZeileEingefuegt = True
            Else
                codNennMass.add dNennMass, , lElement               ' Zeile vorher einfgen
                cosToleranz.add sToleranz, , lElement
                codUnteresAbmass.add dUnteresAbmass, , lElement
                codOberesAbmass.add dOberesAbmass, , lElement
                bZeileEingefuegt = True
            End If
            Exit For                                                ' fertig
        End If
    Next lElement
    
    If (bZeileEingefuegt = False) Then                              ' ansonsten Element einfach hinten
        codNennMass.add dNennMass                                   ' anhngen !
        cosToleranz.add sToleranz
        codUnteresAbmass.add dUnteresAbmass
        codOberesAbmass.add dOberesAbmass
    End If
End Sub
' liest aus der Collection die Werte der Reihe nach aus !
Public Function leseWerte(ByRef dNennMass As Double, ByRef sToleranz As String, ByRef dUnteresAbmass As Double, ByRef dOberesAbmass As Double) As Boolean
    Static lAktuellerWert As Long
    Dim bWeitereWerte As Boolean
    
    If (codNennMass.Count = lAktuellerWert) Then            ' schon alles gelesen !
        bWeitereWerte = False
    Else
        lAktuellerWert = lAktuellerWert + 1
        bWeitereWerte = True
        dNennMass = codNennMass.Item(lAktuellerWert)
        sToleranz = cosToleranz.Item(lAktuellerWert)
        dUnteresAbmass = codUnteresAbmass.Item(lAktuellerWert)
        dOberesAbmass = codOberesAbmass.Item(lAktuellerWert)
    End If
    
    leseWerte = bWeitereWerte
End Function
' gibt an, ob berhaupt Werte existieren !
Public Function existierenWerte() As Boolean
    If (codNennMass.Count > 0) Then
        existierenWerte = True
    Else
        existierenWerte = False
    End If
End Function
' Collection wieder freigeben
Private Sub Class_Terminate()
    Set codNennMass = Nothing
    Set cosToleranz = Nothing
    Set codUnteresAbmass = Nothing
    Set codOberesAbmass = Nothing
End Sub
